/*
 * IRDA.c
 * 
 * Copyright 2013 Stefan Mavrodiev <support@olimex.com>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */


#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>
#include "i2c.h"

#pragma GCC diagnostic ignored "-Wdeprecated-declarations"

char port[30];
char ch[10];
int address;
int mode;
int command;
int device;
unsigned char buffer[10];

int main(int argc, char **argv)
{
    int fd;
    int choice;
    
    while(1)
    {
        static struct option long_options[]=
		{
			{"i2c", required_argument, 0, 'i'},
            {"verbose", no_argument, &_DEBUG, 1},
			{0,		0, 			0,		0}
		};
        
        int option_index = 0;
		int c = getopt_long(argc, argv, "i:", long_options, &option_index);
		
		if (c == -1)
		{
			break;
		}
		
		switch(c)
		{				
			case 'i':
                strcpy(port, optarg);
                printf("Selected port: %s\n", port);
                break;
                
				
			case '?':
                return EXIT_FAILURE;
				break;
				
			default:
				break;
		}
    }
    
        
    printf("\nMOD-IRDA+\n");
    printf("1: Set MODE(SIRC or RC5)\n");
    printf("2: Send COMMAND and ADDRESS\n");
    printf("3: Read last recieved COMMAND and ADDRESS\n");
    printf("0: Exit\n\n");
    
    do
    {
        printf("Enter:");
        scanf("%d", &choice);
        if(choice >= 0 && choice < 4)
                    break;
    }while(1);
    
    
    printf("ADDRESS: ");
    scanf("%s", ch);
       
    
    
    switch(choice)
    {
            
        case 1:
            do
            {
                printf("RC5[0] or SIRC[1]:");
                scanf("%d", &mode);
                if(mode >= 0 && mode < 2)
                        break;
            }while(1);
            
            
            I2C_Open(&fd, port, 0x48);   
    
            buffer[0] = 0x06;
            buffer[1] = strtol(ch, NULL, 0);
            buffer[2] = 0x01;
            buffer[3] = mode;
            I2C_Send(&fd, buffer, 4);
            I2C_Close(&fd);
            break;
    }
        
    return 0;
    
}

